Opt('GUIOnEventMode', 1)


#include 'cefau3.au3'
#include <GUIConstants.au3>
#include <GUIConstantsEx.au3>
#include <FontConstants.au3>
#include <ColorConstants.au3>
#Include <WinAPI.au3>
#include <GuiListView.au3>
#include <WindowsConstants.au3>
#include <Array.au3>
#include <Misc.au3>
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <StaticConstants.au3>
#include <StaticConstants.au3>
#include <GuiComboBox.au3>
#include <ClipBoard.au3>
#include <WinAPIDiag.au3>
#include <Inet.au3>

Global $hLV, $aItems, $idLV, $idSearchText, $HandleidSearchText, $ultimapalavra

$ultimapalavra = '0'

global $cef = CefStart(default)

$cef.EnableHighDPISupport()

global $cef_app = $cef.new('App'), _
	$cef_args = $cef.new('MainArgs')	

if ($cef.ExecuteProcess($cef_args.__ptr, $cef_app.__ptr) >= 0) then exit

global $width = 1300, $height = 500, $gui_title = 'GLOSSARIUM Inglês <> Português (windows edition) - by DicionarioTecnico.com'
	;$url = 'https://www.dicionariotecnico.com/'
	$url = 'http://127.0.0.1:8080/index.php'


;;;;;;;;;; GUI CREATE ;;;;;;;;;;;;


global $hMainGUI = GUICreate($gui_title, $width, $height, -1, -1, 0x00CF0000)
;GUISetBkColor(0xffffff)
GUISetBkColor(0xFFFBF0)

Local Const $sFont = "Arial"
$hFont = _WinAPI_CreateFont(21, 9, 0, 0, $FW_NORMAL, False, False, False, $DEFAULT_CHARSET, $OUT_DEFAULT_PRECIS, $CLIP_DEFAULT_PRECIS, $DEFAULT_QUALITY, 0, 'Arial')
; COMBOBOX TERMOS

Global $CmbTermos = GUICtrlCreateCombo("", 10, 100, 220, 45)
; Add additional items to the combobox.
GUICtrlSetData($CmbTermos, "DUMMY 2|DUMMY 3|DUMMY 4|DUMMY 5")
GUIctrlsetfont(-1, 15, $FW_NORMAL,$GUI_FONTNORMAL,$sFont)
GUICtrlSetResizing(-1,$GUI_DOCKALL)

  ; Create ListView
$idLV = GUICtrlCreateListView( "", 10, 130, 220, 500, BitOr($LVS_SORTASCENDING,$LVS_SINGLESEL, $LVS_EX_BORDERSELECT, $LVS_OWNERDATA, $LVS_NOCOLUMNHEADER, $LVS_SHOWSELALWAYS), BitOR( $WS_EX_CLIENTEDGE, $LVS_EX_DOUBLEBUFFER, $LVS_EX_FULLROWSELECT, $LVS_EX_FLATSB,$LVS_EX_INFOTIP))
  $hLV = GUICtrlGetHandle( $idLV ) ;                               Virtual listview                          Reduces flicker
_WinAPI_SetFont($hLV, $hFont, True)
_GUICtrlListView_SetOutlineColor ( $hLV, $CLR_WHITE)
_GUICtrlListView_SetTextBkColor ( $hLV, 0xfcfcfc )
_GUICtrlListView_SetOutlineColor ( $hLV, 0xffffe8 )
_GUICtrlListView_SetBkColor ( $hLV, 0xf2f2f2 )
_GUICtrlListView_AddColumn( $hLV, "", 220)
GUICtrlSetResizing(-1,$GUI_DOCKALL)

; DUMMY PARA RECEBER PALAVRA NO MESSAGE LOOp
Global $dummyPalavra = GUICtrlCreateDummy()


; DUMMY CONTROLS
; SE TIRAR BUGA!! BIZARRO.
Global $input_url = GUICtrlCreateInput('', 5, 5555, $width - 55, 25)
GUICtrlSetFont(-1, 14)
GUICtrlSetResizing(-1, 544)
Global $btn_go = GUICtrlCreateButton("Go", $width - 45, 5555, 40, 25)
GUICtrlSetFont(-1, 14)
GUICtrlSetResizing(-1, 544)
GUICtrlSetOnEvent(-1, '__go')

GUISetOnEvent(-3, __exit)
; GUICtrlSetOnEvent($CmbTermos,__cmbTermosChange)


  ; WM_NOTIFY message handler
  GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")
;  GUIRegisterMsg($WM_COMMAND, "WM_COMMAND")
GUIRegisterMsg($WM_COMMAND, "MY_WM_COMMAND")
  
   
  
;;;;;;;;;;;;; END GUI CREATE ;;;;;;;;;

global $cef_settings = $cef.new('Settings'), _
	$cef_bs = $cef.new('BrowserSettings')

; COOKIES PERSISTENT PQP!!
$cef_settings.cache_path('cache')
$cef_settings.persist_session_cookies = 1

$cef_settings.single_process = @Compiled ? 0 : 1
$cef_settings.multi_threaded_message_loop = 1

if ($cef.Initialize($cef_args.__ptr, $cef_settings.__ptr, $cef_app.__ptr) == 0) then exit

global $cef_wininfo = $cef.new('WindowInfo')
$cef_wininfo.parent_window = $hMainGUI
$cef_wininfo.style 	= BitOr($WS_CHILD,$WS_VISIBLE,$WS_BORDER) ; 0x50000000
$cef_wininfo.x 		= 250
$cef_wininfo.y 		= 100
$cef_wininfo.width 	= $width - 255
$cef_wininfo.height = $height - 105

global $cef_client = $cef.new('Client'), _
	$cef_lifespan = $cef.new('LifeSpanHandler'), _
	$cef_display = $cef.new('DisplayHandler')

$cef_client.GetLifeSpanHandler 	= __getLifeSpanHandler
$cef_client.GetDisplayHandler 	= __getDisplayHandler

$cef_lifespan.OnAfterCreated 	= __onAfterCreated

$cef_display.OnTitleChange		= __onTitleChange
$cef_display.OnAddressChange	= __onAddressChange

$cef.CreateBrowser($cef_wininfo.__ptr, $cef_client.__ptr, $url, $cef_bs.__ptr, Null)

global $cef_browser_hwnd = null, _
	$cef_browser, $cef_browser_host, $cef_frame

GUIRegisterMsg($WM_SIZE, __sizing)
;GUIRegisterMsg($WM_SYSCOMMAND, __sizing)
GUISetState()
;GUISetState(@SW_MAXIMIZE)

GUICtrlSetState($CmbTermos, $GUI_FOCUS)

global $rc = DllStructCreate('int[2];int w;int h')

OnAutoItExitRegister('CefExit')

 ; Load data from CSV-file
  $aItems = FileReadToArray("preliminar.txt")
  GUICtrlSendMsg( $idLV, $LVM_SETITEMCOUNT, UBound( $aItems ), 0 )
sleep(50)

	;AdlibRegister("CheckChangeNavigate", 2000)


CefWndMsg_RunLoop()

  ; MsgBox(0,"",UBound( $aItems ))

While 1

			ConsoleWrite("CHEGOU " & $dummtPalavra)
	if GUICtrlRead($dummyPalavra) <> "0" And GUICtrlRead($dummyPalavra) <> $ultimapalavra  Then 

     $cef_frame.LoadURL("http://www.dicionariotecnico.com/traducao.php?termo=" & GUICtrlRead($dummyPalavra))
     $ultimapalavra = GUICtrlRead($dummyPalavra)
   EndIf


WEnd




func __exit()
	GUISetState(@SW_HIDE)
	CefWndMsg_QuitLoop()
	exit
endfunc

func __go()
	$url = GUICtrlRead($input_url)
	$cef_frame.LoadURL($url)
endfunc

func __sizing($hwnd, $msg, $wp, $lp)
	if ($cef_browser_hwnd) then
		dllcall('user32', 'bool', 'GetClientRect', 'hwnd', $hMainGUI, 'struct*', $rc)
		_MoveWindow($cef_browser_hwnd, 250, 100, $rc.w - 255, $rc.h - 105, 0)
	endif
endfunc

func __getLifeSpanHandler()
	return $cef_lifespan.__ptr
endfunc

func __getDisplayHandler()
	return $cef_display.__ptr
endfunc

func __onAfterCreated($browser)
	if (not $cef_browser_hwnd) then
		$cef_browser = $browser
		$cef_browser_hwnd = $browser.GetHost().GetWindowHandle()
		_ShowWindow($cef_browser_hwnd, 5)
		$cef_frame = $browser.GetMainFrame()
	endif
	GUICtrlSetState($CmbTermos, $GUI_FOCUS)
	ControlClick($hMainGUI, "", $CmbTermos)
endfunc

func __onTitleChange($browser, $title)
	; WinSetTitle($hMainGUI, '', $gui_title & ' :: ' & $title.val)
endfunc

func __onAddressChange($browser, $frame, $url)
	GUICtrlSetData($input_url, $url.val)
endfunc

;_WinAPI_SetFocus(ControlGetHandle("", "", $CmbTermos))











Func WM_COMMAND($hWnd, $iMsg, $wParam, $lParam)
    Local $hdlWindowFrom, _
          $intMessageCode, _
          $intControlID_From

    $intControlID_From =  BitAND($wParam, 0xFFFF)
    $intMessageCode = BitShift($wParam, 16)

   ; Switch $intControlID_From
   ;     Case $idSearchText
   ;         Switch $intMessageCode
   ;             Case $EN_CHANGE
   ;                 ConsoleWrite("[" & _Now() & "] - The text in the $txtInput control has changed! Text = " & GUICtrlRead($idSearchText) & @CRLF)
;					GUICtrlSetState($idLV, $GUI_FOCUS)
;					   ; msgbox(0, SearchText(DllStructGetData($tNMLVFINDITEM, "Start" ), GUICtrlRead($idSearchText)  ) )
;					ControlSend($hMainGUI, "", $idLV, GUICtrlRead($idSearchText), 1)
;					;GUICtrlSetState($idSearchText, $GUI_FOCUS)
 ;           EndSwitch
  ;  EndSwitch

    Return $GUI_RUNDEFMSG

EndFunc




Func WM_NOTIFY( $hWnd, $iMsg, $wParam, $lParam )
  Static $tagNMLVCACHEHINT = $tagNMHDR & ";int iFrom;int iTo"
  Static $tText = DllStructCreate( "wchar[50]" )
  Static $pText = DllStructGetPtr( $tText )
  Static $aDisplay[100][10], $iRows, $iFrom


  Local $tNMHDR = DllStructCreate( $tagNMHDR, $lParam )
  Local $hWndFrom = HWnd( DllStructGetData( $tNMHDR, "hWndFrom" ) )
  Local $iCode = DllStructGetData( $tNMHDR, "Code" )

  Switch $hWndFrom


    Case $hLV
	
      Switch $iCode

                Case $NM_CLICK ; Sent by a list-view control when the user clicks an item with the left mouse button
					ConsoleWrite($lParam)
					
                    $tInfo = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					$index = DllStructGetData($tInfo, "Index")
					
                    _DebugPrint($aItems[$index])
					
					; $ultimapalavra = $aItems[$index]
					GUICtrlSetData($dummyPalavra, $aItems[$index])
					;AdlibRegister("CheckChangeNavigate", 100)
					
                Case $LVN_KEYDOWN
                    $tNMLVKEYDOWN = DllStructCreate($tagNMHDR & ";short VKey;uint Flags", $lParam)
					
					$vKey = DllStructGetData($tNMLVKEYDOWN, "VKey")
					
                    ;ConsoleWrite("Virtual key code: " & $vKey & @LF)
					
					;If $vKey = 13 Then
						       ; _DebugPrint($aItems[$index])
					;   			GUICtrlSetData($dummyPalavra, $aItems[$index])	
					;EndIf
					
					
					;If $vKey = 38 or $vKey = 40 Then
						
						;ConsoleWrite(_GUICtrlListView_GetSelectedIndices($idLV))
                   ; $tInfo = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					;$index = DllStructGetData($tInfo, "Index")
					
					;GUICtrlSetData($idSearchText,$aItems[_GUICtrlListView_GetSelectedIndices($idLV)])
					
					;_GUICtrlEdit_SetText($idSearchText,$aItems[_GUICtrlListView_GetSelectedIndices($idLV)] )
                    
					  
			;	  EndIf
				  
        Case $LVN_GETDISPINFOW
          Local $tNMLVDISPINFO = DllStructCreate( $tagNMLVDISPINFO, $lParam )
          If BitAND( DllStructGetData( $tNMLVDISPINFO, "Mask" ), $LVIF_TEXT ) Then
            Local $iIndex = DllStructGetData( $tNMLVDISPINFO, "Item" ) - $iFrom
            If $iIndex >= 0 And $iIndex < $iRows Then
			  Local $sItem = $aDisplay[$iIndex][DllStructGetData($tNMLVDISPINFO,"SubItem")]
              DllStructSetData( $tText, 1, $sItem )
              DllStructSetData( $tNMLVDISPINFO, "Text", $pText )
              DllStructSetData( $tNMLVDISPINFO, "TextMax", StringLen( $sItem ) )
            EndIf
          EndIf

        Case $LVN_ODCACHEHINT
          Local $tNMLVCACHEHINT = DllStructCreate( $tagNMLVCACHEHINT, $lParam )
          Local $iTo = DllStructGetData( $tNMLVCACHEHINT, "iTo" ), $aSubItems
          $iFrom = DllStructGetData( $tNMLVCACHEHINT, "iFrom" )
          $iRows = 0
          For $i = $iFrom To $iTo
            ;$aSubItems = StringSplit( $aItems[$i], ",", 2 ) ; 2 = $STR_NOCOUNT
	
              $aDisplay[$iRows][0] = $aItems[$i]

            $iRows += 1
          Next

Case $LVN_ODFINDITEMW
	;MsgBox			(0,"",$iCode)
  Local $tNMLVFINDITEM = DllStructCreate( $tagNMLVFINDITEM, $lParam )
  If BitAND( DllStructGetData( $tNMLVFINDITEM, "Flags" ), $LVFI_STRING ) Then
    Return SearchText( DllStructGetData( $tNMLVFINDITEM, "Start" ), _                                     ; Start
      DllStructGetData( DllStructCreate( "wchar[20]", DllStructGetData( $tNMLVFINDITEM, "Text" ) ), 1 ) ) ; Text
  EndIf




        Case $NM_CUSTOMDRAW
          Local $tNMLVCUSTOMDRAW = DllStructCreate($tagNMLVCUSTOMDRAW, $lParam)
          Local $dwDrawStage = DllStructGetData($tNMLVCUSTOMDRAW, "dwDrawStage")
          Local $dwItemSpec  = DllStructGetData($tNMLVCUSTOMDRAW, "dwItemSpec")

          Switch $dwDrawStage                ; Holds a value that specifies the drawing stage

            Case $CDDS_PREPAINT
              ; Before the paint cycle begins
              Return $CDRF_NOTIFYITEMDRAW    ; Notify the parent window of any item-related drawing operations

            Case $CDDS_ITEMPREPAINT
              ; Before painting an item
							If Mod( $dwItemSpec, 2 ) = 0 Then
								DllStructSetData( $tNMLVCUSTOMDRAW, "ClrTextBk", 0xFFFFFF )
							Else
								DllStructSetData( $tNMLVCUSTOMDRAW, "ClrTextBk", 0xe3e3e3)
							EndIf
              Return $CDRF_NEWFONT           ; $CDRF_NEWFONT must be returned after changing font or colors

         EndSwitch
		  
		  
		  
      EndSwitch

  EndSwitch

  Return $GUI_RUNDEFMSG
;  #forceref $hWnd, $iMsg, $wParam
EndFunc






Func SearchText( $lo, $s )
	ConsoleWrite($lo & " - " & $s & @CRLF)
	Local $lo0 = $lo
	If $lo > UBound( $aItems ) - 1 Then
		$lo = 0
	EndIf
		
	If Not StringCompare( $s, StringLeft( $aItems[$lo], StringLen( $s ) ) ) Then
		; Current row ($lo) matches search string
		Return $lo
	EndIf

	; Search from current row ($lo) to last row
	Local $hi = UBound( $aItems ) - 1, $mi
	$mi = BinSearch( $lo, $hi, $s )
	If $mi > -1 Then
		; Found
		Return $mi
	EndIf

	; Not found
	If $lo0 < UBound( $aItems ) - 1 Then
		; Search from first row to current row ($lo)
		$lo = 0
		$hi = $lo0
		Return BinSearch( $lo, $hi, $s )
	EndIf

	Return -1
EndFunc

Func BinSearch( $lo, $hi, $s )
	Local $mi, $l = StringLen( $s ), $t
	While $lo <= $hi
		$mi = Int( ( $lo + $hi ) / 2 )
		$t = StringLeft( $aItems[$mi], $l )
		If StringCompare( $s, $t ) < 0 Then
			$hi = $mi - 1
		ElseIf StringCompare( $s, $t ) > 0 Then
			$lo = $mi + 1
		Else ; Found
			; Find first row that matches the string
			While $mi And Not StringCompare( $s, StringLeft( $aItems[$mi-1], $l ) )
				$mi -= 1
			WEnd
			Return $mi
		EndIf
	WEnd
	Return -1
EndFunc


Func _DebugPrint($s_text, $line = @ScriptLineNumber)
    ConsoleWrite( _
            "!===========================================================" & @LF & _
            "+======================================================" & @LF & _
            "-->Line(" & StringFormat("%04d", $line) & "):" & @TAB & $s_text & @LF & _
            "+======================================================" & @LF)
EndFunc   ;==>_DebugPrint
		
		


Func MY_WM_COMMAND($hWnd, $msg, $wParam, $lParam)
    Local $nNotifyCode = _HiWord($wParam)
    Local $nID = _LoWord($wParam)
    Local $hCtrl = $lParam
    
    Switch $nID
        Case $CmbTermos
            Switch $nNotifyCode
                Case $CBN_EDITUPDATE ; when user types in new data
                    _Combo_Changed()
                Case $CBN_SELCHANGE ; item from drop down selected
                    _Combo_Changed()
            EndSwitch
    EndSwitch
    ; Proceed the default Autoit3 internal message commands.
    ; You also can complete let the line out.
    ; !!! But only 'Return' (without any value) will not proceed
    ; the default Autoit3-message in the future !!!
    Return $GUI_RUNDEFMSG
EndFunc   ;==>MY_WM_COMMAND

Func _HiWord($x)
    Return BitShift($x, 16)
EndFunc   ;==>_HiWord

Func _LoWord($x)
    Return BitAND($x, 0xFFFF)
EndFunc   ;==>_LoWord


Func  _Combo_Changed()
	ConsoleWrite("[" & _Now() & "] - The text in the $CmbTermos control has changed! Text = " & GUICtrlRead($CmbTermos) & @CRLF)
	;controlSend($hMainGUI, "", $idLV, GUICtrlRead($CmbTermos), 1)
	GUICtrlSendMsg($idLV, $LVN_ODFINDITEMW, GUICtrlRead($CmbTermos), GUICtrlRead($CmbTermos))
	
				;		$cef_frame = $cef_browser.GetMainFrame()
				;	$cef_frame.LoadURL("http://127.0.0.1:8080/traducao.php?termo=" & _URIEncode(GUICtrlRead($CmbTermos)))
;$hLV
EndFunc


Func CheckChangeNavigate()
;					msgbox(0,"","hi")
					;$cef_frame = $cef_browser.GetMainFrame()
;MsgBox(0,"",$dummyPalavra)
;MsgBox(0,"",$ultimaPalavra)
if GUICtrlRead($dummyPalavra) <> "0" Then
  $cef_frame.LoadURL("http://www.dicionariotecnico.com/traducao.php?termo=" & GUICtrlRead($dummyPalavra))
EndIf
;GUICtrlSetState($idLV, $GUI_FOCUS)
	AdlibUnRegister("CheckChangeNavigate")
EndFunc
				
