﻿; #RequireAdmin 
#NoTrayIcon

#AutoIt3Wrapper_Run_AU3Check=Y
#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6 -w 7
#AutoIt3Wrapper_Version=0.1
#AutoIt3Wrapper_Icon=favicon.ico
#AutoIt3Wrapper_OutFile=DicionarioTecnico
#AutoIt3Wrapper_OutFile_Type=a3x
#AutoIt3Wrapper_Res_Comment=Dicionario Técnico para Windows - versão 0.1
#AutoIt3Wrapper_Res_Description=Dicionario Técnico para Windows - versão 0.1
#AutoIt3Wrapper_Res_Fileversion=0.1
#AutoIt3Wrapper_Res_ProductVersion=0.1
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_LegalCopyright=www.dicionariotecnico.com

#include <GUIConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <GuiListView.au3>
#include <Array.au3>
#include <Misc.au3>
#include <ColorConstants.au3>
#include <FontConstants.au3>
#include <Process.au3>
#include<WinAPI.au3>
#include <GuiComboBox.au3>
#include <file.au3>
#include <Inet.au3>
#include <String.au3>

#include <_IEEmbedded2.au3>

;#include <GDIPlus.au3>
#include <WindowsConstants.au3>

Local $hDLL = DllOpen("user32.dll")

; update ie latest version
Local $regValue = "0x2AF8"
RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION", _ProcessGetName(@AutoItPID), "REG_DWORD", $regValue)
RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Internet Explorer\MAIN\FeatureControl\FEATURE_BROWSER_EMULATION", _ProcessGetName(@AutoItPID), "REG_DWORD", $regValue)
RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION", @ScriptName, "REG_DWORD", 11001)
RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION", "AutoIt3.exe", "REG_DWORD", 11001)
RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION", "autoit3_x64.exe", "REG_DWORD", 11001)

; Kill IE (not needed)

;   $Proc = "iexplore.exe"
;   While ProcessExists($Proc)
;      ProcessClose($Proc)
;   Wend




;global $OBJECT = ObjCreate("Shell.Explorer.2")
;Global $OBJECT_CTRL = GUICtrlCreateObj($OBJECT, 350, 150, 1000, 688)


; Trava posicionamento todos os componentes (no resize / no move)
Opt("GUIResizeMode",$GUI_DOCKALL)


Global $hGui, $hEdit, $idEditSearch, $hLV, $aItems[], $aSearch[], $aOriginal[], $iSearch = 0

Global $loading = False ; Boolenaa de controle para carregamento da lista de termos

global $direction = 1 ; ing -> pt = 1; pt -> ing = 2; siglas = 3

global $rc = DllStructCreate('int[2];int w;int h')

global $LoadingLocation = "https://www.dicionariotecnico.com/index_app.php"  ; variavel controle para loading do IE

global  $lastTermoBusca = ""

global $disableChange=False

global $localdebugmode = false

Global $modoSearch = 1  ; pesquisa normal = 1; pesquisa de corpus = 2

Global $page = "traducao_app.php"

global $termoatual = ""

global $version = "0.1"
global $lastversion = ""



;HotKeySet("{F1}", "debug")
;HotKeySet("{F2}", "debug2")
;HotKeySet("{F3}", "carregaListaPT")
;HotKeySet("^c", "_shortcut")

$gui_title = "DicionárioTécnico.com Inglês <> Português - Windows Edition (versão " & $version & " BETA)"

 Func _killOriginal($winTitle)
  Local $processID = WinGetProcess($winTitle)
  While WinExists($winTitle) 
    WinClose($winTitle)
    Sleep(10) ; allow window to exit
    ProcessClose($processID)
    Sleep(10) ; allow process to exit
  WEnd
EndFunc   ;==>_killOriginal
_killOriginal($gui_title)

  ; Create GUI
  $hGui = GUICreate($gui_title, 1280, 630,-1, -1, 0x00CF0000 )
  ;GUISetBkColor($COLOR_BLACK)
  
 

  GUIsetIcon(@ScriptDir & "\favicon.ico",-1)
  ;TraySetIcon(@ScriptDir & "\favicon.ico")

  
  
  ; logo
  $idPic = GUICtrlCreatePic(@ScriptDir & "\logo_dic.gif", 10, 10, 630, 82)
  
  $BtnReverse = GUICtrlCreateButton ("", 10, 100,140, 36, $BS_BITMAP)
  GUICtrlSetImage (-1, "en_pt.bmp")
  GUICtrlSetCursor (-1, 0)
  ;GUICtrlSetOnEvent($BtnIngPt,__BtnDirectionChange)
  GUICtrlSetTip (-1, "Change direction")

  $BtnSiglas = GUICtrlCreateButton ("", 160, 100,140, 36, $BS_BITMAP)
  GUICtrlSetImage (-1, @ScriptDir & "\siglas.bmp")
  GUICtrlSetCursor (-1, 0)
  ;GUICtrlSetOnEvent($BtnIngPt,__BtnDirectionChange)
  GUICtrlSetTip (-1, "Acronyms search")



  ; Create Edit control
  Global $idEdit = GUICtrlCreateInput( "", 10, 150, 300-20, 30)
  GUIctrlsetfont(-1, 15, $FW_NORMAL,$GUI_FONTNORMAL,"Tahoma")
  GUICtrlSetBkColor (-1, 0xFEFDEB)
  $hEdit = GUICtrlGetHandle( $idEdit )
  $idEditSearch = GUICtrlCreateDummy()


  ; Handle $WM_COMMAND messages from Edit control
  ; To be able to read the search string dynamically while it's typed in
  GUIRegisterMsg( $WM_COMMAND, "WM_COMMAND" )
  GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")
  GUIRegisterMsg($WM_SIZE, '__sizing')
  
  ; Create ListView
  Local $idLV = GUICtrlCreateListView( "", 10, 180, 280, 580, BitOr($LVS_SINGLESEL, $LVS_OWNERDATA, $LVS_NOCOLUMNHEADER, $LVS_SHOWSELALWAYS), BitOR( $WS_EX_CLIENTEDGE, $LVS_EX_DOUBLEBUFFER, $LVS_EX_FULLROWSELECT, $LVS_EX_FLATSB,$LVS_EX_INFOTIP,$LVS_EX_GRIDLINES))
  $hLV = GUICtrlGetHandle( $idLV ) ;                               Virtual listview                          Reduces flicker
  _GUICtrlListView_AddColumn( $hLV, "Items",  259 )
  GUICtrlSetCursor (-1, 0)
  GUIctrlsetfont(-1, 13, $FW_NORMAL,$GUI_FONTNORMAL,"Tahoma")
  
  $pos = WinGetPos($hGUI);$hGUI is your GUI handle 
   ConsoleWrite($pos[3]);[0]=left, [1]=top, [2]=width, [3]=height

  ; label contagem termos
  $LblTotal = GUICtrlCreateLabel("Total:", 60, 605, 80, 25) 
  GUICtrlSetFont(-1, 12, 500, 0, "Tahoma")
  ; label contagem termos
  $LblTermos = GUICtrlCreateLabel("0", 110, 605, 150, 25) 
  GUICtrlSetFont(-1, 12, 500, 0, "Tahoma")
  GUICtrlSetColor(-1, 0xFF0000) ; Red


  ; Handle $WM_NOTIFY messages from ListView
  ; Necessary to display the rows in a virtual ListView
  GUIRegisterMsg( $WM_NOTIFY, "WM_NOTIFY" )

Global $oIE = _IECreateEmbedded()  ; ObjCreate("Shell.Explorer.2")
; global $oIE = ObjCreate("Shell.Explorer.2")
 
global $GUIoIE = GUICtrlCreateObj($oIE, 300, 150, 1055, 540)
;GUICtrlSetResizing (-1,$GUI_DOCKBORDERS) ; <---- Added this line

;Local $oIE = _IEEmbedded2_Create($hGUI, 300, 150, 1055, 540, "https://www.dicionariotecnico.com/index_app.php", Default, Default, Default)
;Local $oIE = _IEEmbedded2_Create($hGUI, 300, 150, 1055, 540, "about:blank", Default, Default, Default)
;_IEEmbedded2_Hide()

   
   ; COMBO AREAS TECNICAS

$Label12 = GUICtrlCreateLabel("Área Técnica:", 464, 95, 126, 24)
GUICtrlSetFont(-1, 12, 600, 0, "Tahoma")
$CmbAreaTecnica= GUICtrlCreateCombo("", 373, 117, 300, 20, BitOr($CBS_DROPDOWNLIST, $WS_VSCROLL))
GUICtrlSetFont(-1, 12, 400, 0, "Tahoma")
GUICtrlSetData(-1, "<Todos os termos>","<Todos os termos>")
GUICtrlSetCursor (-1, 0)

; BTN CLEAR FILTER
  $BtnClearFilter = GUICtrlCreateButton("", 675, 117,28, 28, $BS_BITMAP)
  GUICtrlSetImage (-1, @ScriptDir & "\btn_clear.bmp")
  GUICtrlSetCursor (-1, 0)
  ;GUICtrlSetOnEvent($BtnIngPt,__BtnDirectionChange)


$Label13 = GUICtrlCreateLabel("Modo de pesquisa:", 864, 95, 226, 24)
GUICtrlSetFont(-1, 12, 600, 0, "Tahoma")

GUIStartGroup()
Local $idRadio1 = GUICtrlCreateRadio("Dicionário normal", 794, 120, 150, 20)
GUICtrlSetFont(-1, 12, 400, 0, "Tahoma")
  GUICtrlSetCursor (-1, 0)
Local $idRadio2 = GUICtrlCreateRadio("Pesquisa de Corpus", 954, 120, 180, 20)
GUICtrlSetFont(-1, 12, 400, 0, "Tahoma")
  GUICtrlSetCursor (-1, 0)

; Frame radio
        GUICtrlSetState($idRadio1, $GUI_CHECKED)
$hGroup_1 = GUICtrlCreateGroup("", 760, 85, 380, 60)


$Label12 = GUICtrlCreateLabel("Dica:", 674, 15, 126, 24)
GUICtrlSetFont(-1, 12, 600, 0, "Tahoma")
$Label12 = GUICtrlCreateLabel("Utilize o atalho CONTROL+C+C  (2x) para pesquisar um termo selecionado", 724, 15, 726, 44)
GUICtrlSetFont(-1, 12, 400, 0, "Tahoma")

; BOTAO ASSINE Ja

$BtnAssine = GUICtrlCreateButton("ASSINE JÁ", 1170, 100, 155, 40, $BS_CENTER)
GUICtrlSetBkColor(-1, $COLOR_White)
GUICtrlSetFont($BtnAssine, 14, 800, 0, "Tahoma", 5)
GUICtrlSetColor($BtnAssine, 0xFF0000)
GUICtrlSetCursor (-1, 0)
GUICtrlSetState(-1, $GUI_HIDE)

; NAV BUTTON BROWSER
; botoes navegação browser



  $BtnBack = GUICtrlCreateButton ("", 870, 45,38, 38, $BS_BITMAP)
  GUICtrlSetImage (-1, @ScriptDir & "\back.bmp")
  GUICtrlSetCursor (-1, 0)
  GUICtrlSetTip (-1, "BACK")
  $BtnForward = GUICtrlCreateButton ("", 910, 45,38, 38, $BS_BITMAP)
  GUICtrlSetImage (-1, @ScriptDir & "\forward.bmp")
  GUICtrlSetCursor (-1, 0)
  GUICtrlSetTip (-1, "FORWARD")

  $BtnStop= GUICtrlCreateButton ("", 950, 45,38, 38, $BS_BITMAP)
  GUICtrlSetImage (-1, @ScriptDir & "\stop.bmp")
  GUICtrlSetCursor (-1, 0)
  GUICtrlSetTip (-1, "STOP LOADING")

  $BtnRefresh= GUICtrlCreateButton ("", 990, 45,38, 38, $BS_BITMAP)
  GUICtrlSetImage (-1, @ScriptDir & "\refresh.bmp")
  GUICtrlSetCursor (-1, 0)
    GUICtrlSetTip (-1, "REFRESH PAGE")


	 
; Show GUI
  GUISetState( @SW_SHOW )
;  GUISetState(@SW_MAXIMIZE)
  

CarregaAnimacao()

   _IENavigate($oIE,"about:blank") 
   
  ; carrega áreas técnicas para combo
$file = FileReadToArray(@ScriptDir & "\areas.txt")

; Read in lines of text until the EOF is reached
for $i = 0 to ubound($file) - 1
   _GUICtrlComboBox_AddString($CmbAreaTecnica, $file[$i])
next 

FileClose($file)

; ACCELERATORS: KEYPRESS DETECTION PARA ENTER SEM INTERRUPÇÃO NO FORM

;$iENTER = GUICtrlCreateDummy()
$upArrow= GUICtrlCreateDummy()
$downArrow = GUICtrlCreateDummy()
$clicoulista = GUICtrlCreateDummy()  
;dim $AccelKeys[1][2] = [["{ENTER}", $iENTER]]; Set accelerators

;Local $aAccelKeys[3][2] = [["{ENTER}", $iENTER], ["{UP}", $upArrow], ["{DOWN}", $downArrow]]
;GUISetAccelerators($AccelKeys)



carregaListaEN()

;$aOriginal = $aSearch ; criei esse Array para nao ter que dar reload toda hora na lista completa; um clone
	
  ; Display items
  GUICtrlSendMsg( $idLV, $LVM_SETITEMCOUNT, ubound($aItems), 0 )

 _IEEmbedded2_Show()

$LoadingLocation = "https://www.dicionariotecnico.com/index_app.php"

if $localdebugmode = true Then
_IENavigate($oIE,"http://127.0.0.1:8080/index_app.php") 
Else
_IENavigate($oIE,"https://www.dicionariotecnico.com/index_app.php") 
EndIf

FinishLoading()

;; VERSIONING

$lastversion = _INetGetSource ("https://www.dicionariotecnico.com/dicapp_version.txt",true)
if $lastversion <> $version then
  $yesno = MsgBox($MB_ICONINFORMATION + $MB_YESNO,"NOVA VERSÃO DISPONÍVEL", "Uma nova atualização está disponível (versão " & $lastversion & "). É recomendável atualizar; gostaria de ir ao site agora?", 0, $hGUI)
  if $yesno = $IDYES then ShellExecute("https://www.dicionariotecnico.com/download_windows.php")
	  
	  
 Endif

  ; Message loop
  While 1
	  
    Switch GUIGetMsg()
		
	Case $idEditSearch ; Change no text box: algoritmo de filtragem de termos da lista
		

        Local $sSearch = GUICtrlRead( $idEdit ) ; pega termo do textbox; string de search

	If $lastTermoBusca <> $sSearch and $disableChange = False Then
		 ConsoleWrite ("mudou! antes: " & $lastTermoBusca & "; depois: " & $sSearch)
	    $lastTermoBusca = $sSearch

        If $sSearch = "" Then
          ; Empty search string, display all rows
		 ; $aSearch = $aOriginal
          For $i = 0 To ubound($aItems) - 1
           $aSearch[$i] = $i
		Next
		
          $iSearch = ubound($aItems)
        Elseif $loading = false Then
          ; Find rows matching the search string
          $iSearch = 0
		  
		  ; passa por todos os itens do araray, se coincidir a primeira letra e o começo da palavra for igual ao termo pesquisado, insere no array de busca
          For $i = 0 To ubound($aItems) - 1
			if StringLeft($aItems[$i],1) = StringLeft($sSearch,1) then
            ;If StringInStr( $aItems[$i], $sSearch ) Then ; Normal search
            ;If StringRegExp( $aItems[$i], $sSearch ) Then ; Reg. exp. search
			  If StringLeft( $aItems[$i], StringLen($sSearch)) = $sSearch Then
                $aSearch[$iSearch] = $i
                $iSearch += 1
		      EndIf
	  	    EndIf
		  Next

		  ; passou por todos os itens, se tiver encontrado menos de 100 itens, pega agora os compostos (com espaço antes) e adicionar à string
		 If $iSearch > 0 AND $iSearch < 100 then

	      For $i = 0 To ubound($aItems) - 1
			  
            If StringInStr( $aItems[$i], " " & $sSearch ) Then ; Normal search
            ;If StringRegExp( $aItems[$i], " " & $sSearch ) Then ; Reg. exp. search
              $aSearch[$iSearch] = $i
              $iSearch += 1
		   EndIf
		  Next
	  EndIf
	  
	    ; adiciona substring caso não tenha encontrado nenhum resultado
		 If $iSearch = 0 then
	      For $i = 0 To ubound($aItems) - 1
            If StringInStr( $aItems[$i], $sSearch ) or StringInStr( $aItems[$i], " " & $sSearch ) Then ; Normal search
            ;If StringRegExp( $aItems[$i], $sSearch ) Then ; Reg. exp. search
              $aSearch[$iSearch] = $i
              $iSearch += 1
		   EndIf
		  Next
		EndIf
		
	EndIf
	    ; atualiza filtro do listview virtual, numero de itens encontrados (rows matching)
	       GUICtrlSendMsg( $idLV, $LVM_SETITEMCOUNT, $iSearch, 0 )

    EndIf

		$disableChange=False
        ConsoleWrite( StringFormat( "%4d", $iSearch ) & " rows matching """ & $sSearch & """" & @CRLF )

      Case $GUI_EVENT_CLOSE
        ExitLoop
		
;	  Case $iENTER
;		$a = 1
	  
	Case $clicoulista  ; CLICOU NA LISTA DE TERMOS
	  
		$Index=ControlListView($hGui, "", $idLV,"GetSelected")
		$txt=ControlListView($hGui, "", $idLV,"GetText",$index)
		
		$termoatual =  _URIEncode($txt)
		
		;ControlSend($hGUI, "", $idEdit, $txt, 1)
				$disableChange=True
		GUICtrlSendMsg($idEdit, $WM_SETTEXT, 0, $txt)

		;MsgBox(0, "Test", $txt)
  	$termoatual =  _URIEncode($txt)
	
	if $localdebugmode = true Then
$LoadingLocation = "http://127.0.0.1:8080/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode($txt)
Else
$LoadingLocation = "https://www.dicionariotecnico.com/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode($txt)
EndIf

;SplashTextOn("LOADING!","")			
AdlibRegister("FinishLoading")
CarregaAnimacao()


ConsoleWrite (@CRLF & "http://127.0.0.1:8080/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode($txt))

if $localdebugmode = true Then
_IENavigate($oIE, "http://127.0.0.1:8080/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode($txt))
Else
_IENavigate($oIE, "https://www.dicionariotecnico.com/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode($txt))
EndIf			

    ; BOTAO ASSINE JA
	
	Case $BtnAssine
	   ShellExecute("https://www.dicionariotecnico.com/assine.php")
		
	; RADIO BUTTONS PESQUISA DE CORPUS / NORMAL
	Case $idRadio1				
		if $modoSearch <> 1 Then
			$modoSearch = 1
			if $localdebugmode = true Then
				_IENavigate($oIE, "http://127.0.0.1:8080/" & $page & "?opt=1&dir=" & $direction & "&termo=" & $termoatual)
			Else
				_IENavigate($oIE, "https://www.dicionariotecnico.com/" & $page & "?opt=1&dir=" & $direction & "&termo=" & $termoatual)
			EndIf			
		
		EndIf
		
	Case $idRadio2
		if $modoSearch = 1 Then
		$modoSearch=2
			if $localdebugmode = true Then
				_IENavigate($oIE, "http://127.0.0.1:8080/" & $page & "?opt=1&dir=4&termo=" & $termoatual)
			Else
				_IENavigate($oIE, "https://www.dicionariotecnico.com/" & $page & "?opt=1&dir=4&termo=" & $termoatual)
			EndIf	
		EndIf


	; NAVIGATION BROWSER BUTTONS
	case $BtnBack
	_IEAction($oIE, "back")	
		    SplashOff()
	case $BtnForward 	
		_IEAction($oIE, "forward")
			    SplashOff()
	case $BtnStop
		_IEAction($oIE, "stop")
	    SplashOff()
	case $BtnRefresh
		_IEAction($oIE, "refresh")
			    SplashOff()

	Case $BtnReverse    ; INVERTE IDIOMA DE PARTIDA

	   local $area = GUICtrlRead($CmbAreaTecnica)
      if $direction = 1 Then
		if $area = "<Todos os termos>" Then
	  		GUICtrlSetImage ($BtnReverse, @ScriptDir & "\pt_en.bmp")
	        carregaListaPT()
		    $direction = 2
		Else
	  		GUICtrlSetImage ($BtnReverse, @ScriptDir & "\pt_en.bmp")
		    $direction = 2
			LoadAreaTecnica()
		EndIf
	Else
		if $area = "<Todos os termos>" Then
	     	GUICtrlSetImage ($BtnReverse, @ScriptDir & "\en_pt.bmp")
		    carregaListaEN()
	        $direction = 1
		Else
	     	GUICtrlSetImage ($BtnReverse, @ScriptDir & "\en_pt.bmp")
	        $direction = 1
			LoadAreaTecnica()
		EndIf

	EndIf
		 
	Case $BtnSiglas  ; DICIONARIO DE SIGLAS
		carregaSiglasEN()
	
		Case $CmbAreaTecnica
	
	      LoadAreaTecnica()
		
	Case $BtnClearFilter

		 ResetAreaTecnica()
		 
	Case $GUI_EVENT_CLOSE
		GUIRegisterMsg($WM_TIMER, "")
			_WinAPI_DeleteObject($hHBmp_BG)
			_GDIPlus_Shutdown()
			GUIDelete($hGUI2)
			_IEQuit($oIE)
      Exit
	  
EndSwitch

	if _IsPressed("26", $hDLL) and _OIG_IsFocused($hGui, $idEdit) Then  ; DETECTA DOWN NO EDT
		    GUICtrlSetState($idLV, $GUI_FOCUS)
			ControlSend($hGui, "", $idLV, "{UP}")
	elseif  _IsPressed("28", $hDLL) and _OIG_IsFocused($hGui, $idEdit) Then  ; DETECTA UP NO EDIT
		    GUICtrlSetState($idLV, $GUI_FOCUS)
			ControlSend($hGui, "", $idLV, "{DOWN}")
    elseif _IsPressed("0D", $hDLL) and _OIG_IsFocused($hGui, $idEdit) and WinActive($hGui) Then  ; DETECTA ENTER NO EDIT

	$termoatual =  _URIEncode(GUICtrlRead($idEdit))	
	
if $localdebugmode = true Then
$LoadingLocation = "http://127.0.0.1:8080/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode(GUICtrlRead($idEdit))	
Else
$LoadingLocation = "https://www.dicionariotecnico.com/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode(GUICtrlRead($idEdit))	
EndIf

;SplashTextOn("LOADING!","")	
AdlibRegister("FinishLoading")
CarregaAnimacao()

ConsoleWrite ("RESULT: " & "http://127.0.0.1:8080/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode(GUICtrlRead($idEdit)))
if $localdebugmode = true Then
		_IENavigate($oIE, "http://127.0.0.1:8080/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode(GUICtrlRead($idEdit)))			
Else
		_IENavigate($oIE, "https://www.dicionariotecnico.com/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode(GUICtrlRead($idEdit)))
EndIf
 			GUICtrlSetState($idEdit, $GUI_FOCUS)	
				   ControlSend($hGUI, "", $idEdit, "{RIGHT}", 0)
           ; Sleep(250)
		   
    elseif _IsPressed("0D", $hDLL) and _OIG_IsFocused($hGui, $idLV) Then   ; DETECTA ENTER NO LISTVIEW
            
			   ; GOT THE FUCKING TEXT
				$Index=ControlListView($hGui, "", $idLV,"GetSelected")
				$txt=ControlListView($hGui, "", $idLV,"GetText",$index)
				
				;MsgBox(0, "Test", $aItems[$aSearch[$Index]])
				;$txt=_GUICtrlListView_GetItemText($idLV, $Index)
				;$txt = _GUICtrlListView_GetItem($idLV, $Index)
				;MsgBox(0, "Test", $aItems[_GUICtrlListView_GetSelectedIndices($idLV)])
				;MsgBox(0, "Test", $txt)
$termoatual = _URIEncode($txt)

if $localdebugmode = true Then
	$LoadingLocation = "http://127.0.0.1:8080/" & $page & "?opt=1&dir=" & $direction & "&termo=" & _URIEncode($txt)
Else
	$LoadingLocation = "https://www.dicionariotecnico.com/" & $page & "?opt=1&dir=" & $direction & "&termo=" & _URIEncode($txt)
EndIf

;SplashTextOn("LOADING!","")	
AdlibRegister("FinishLoading")
CarregaAnimacao()

if $localdebugmode = true Then
	_IENavigate($oIE, "http://127.0.0.1:8080/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode($txt))
Else
_IENavigate($oIE, "https://www.dicionariotecnico.com/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode($txt))
EndIf

            ;Sleep(250)
					    GUICtrlSetState($idLV, $GUI_FOCUS)
						
	elseif _IsPressed("11", $hDLL) Then               ; ATALHO CONTROL+C+C
         ;ConsoleWrite("Ctrl is pressed" & @CRLF)
         If _IsPressed("43", $hDLL) Then             
            ConsoleWrite("C is pressed" & @CRLF)
            Do         
            Sleep(10)     
            Until Not (_IsPressed("43", $hDLL))  
            $nBegin = TimerInit()     
            Do         
            If _IsPressed("43", $hDLL) Then   
                  ;ConsoleWrite("C is pressed again" & @CRLF)
                  ;msgbox (0,"","atalho")
				  atalhoSearch()

            EndIf         
            Sleep(10)     
            Until TimerDiff($nBegin) > 300 
         EndIf
	 EndIf

                
				
  ;ConsoleWrite ("|" & _IEPropertyGet($oIE, "readystate"))

; ConsoleWrite ("-" & $oIE.ReadyState) 


WEnd

  GUIDelete()





Func WM_COMMAND( $hWnd, $iMsg, $wParam, $lParam )
  Local $hWndFrom = $lParam
  Local $iCode = BitShift( $wParam, 16 ) ; High word
  Switch $hWndFrom
    Case $hEdit
      Switch $iCode
        Case $EN_CHANGE
          GUICtrlSendToDummy( $idEditSearch )
      EndSwitch
  EndSwitch
  Return $GUI_RUNDEFMSG
EndFunc


; o bichao

Func WM_NOTIFY( $hWnd, $iMsg, $wParam, $lParam )

  Local $tNMHDR, $hWndFrom, $iCode
  $tNMHDR = DllStructCreate( $tagNMHDR, $lParam )
  $hWndFrom = HWnd( DllStructGetData( $tNMHDR, "hWndFrom" ) )
  $iCode = DllStructGetData( $tNMHDR, "Code" )


  Static $tagNMLVCACHEHINT = $tagNMHDR & ";int iFrom;int iTo"
  Static $tText = DllStructCreate( "wchar[50]" )
  Static $pText = DllStructGetPtr( $tText )
  Static $aDisplay[100][10], $iRows, $iFrom


  Switch $hWndFrom


    Case $hLV
	
      Switch $iCode

        Case $LVN_GETDISPINFOW
          Local $tNMLVDISPINFO = DllStructCreate( $tagNMLVDISPINFO, $lParam )
          If BitAND( DllStructGetData( $tNMLVDISPINFO, "Mask" ), $LVIF_TEXT ) AND $loading = false Then
            Local $sItem = $aItems[$aSearch[DllStructGetData($tNMLVDISPINFO,"Item")]]
            DllStructSetData( $tText, 1, $sItem )
            DllStructSetData( $tNMLVDISPINFO, "Text", $pText )
            DllStructSetData( $tNMLVDISPINFO, "TextMax", StringLen( $sItem ) )
		EndIf
		
                Case $NM_CLICK ; Sent by a list-view control when the user clicks an item with the left mouse button
					ConsoleWrite($lParam)
					
                    $tInfo = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					$index = DllStructGetData($tInfo, "Index")
					
					if $index <> -1 Then
						ConsoleWrite("index: " & $index)
						ConsoleWrite($aItems[$index])
					
					; $ultimapalavra = $aItems[$index]
					;GUICtrlSetData($dummyPalavra, $aItems[$index])
					
				    	GUICtrlSendToDummy( $clicoulista )
					EndIf
				
                Case $LVN_KEYDOWN
                    $tNMLVKEYDOWN = DllStructCreate($tagNMHDR & ";short VKey;uint Flags", $lParam)
					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					$index = DllStructGetData($tInfo, "Index")
					
					$vKey = DllStructGetData($tNMLVKEYDOWN, "VKey")
					
                    ConsoleWrite("Virtual key code: " & $vKey & @LF)


;   GUICtrlSetData($dummyChangeListSelContent, $aItems[$index])
			;	GUICtrlSetState($CmbTermos, $GUI_FOCUS)
			
			;ConsoleWrite($aItems[_GUICtrlListView_GetSelectedIndices($idLV)])
				;GUICtrlSetData($dummyChangeListSelContent, $aItems[_GUICtrlListView_GetSelectedIndices($idLV)])
				
						;ConsoleWrite(_GUICtrlListView_GetSelectedIndices($idLV))
                   ; $tInfo = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					;$index = DllStructGetData($tInfo, "Index")
					
					;GUICtrlSetData($idSearchText,$aItems[_GUICtrlListView_GetSelectedIndices($idLV)])
					
					;_GUICtrlEdit_SetText($idSearchText,$aItems[_GUICtrlListView_GetSelectedIndices($idLV)] )
					
				; arrow keys ou backspace na listbox: volta foco para caixa de texto	
				if $vKey = 8 or $vKey = 37 or $vKey = 39  Then 
					
					GUICtrlSetState($idEdit, $GUI_FOCUS)
					
				; qualquer tecla menos page down/up: volta foco para caixa de texto		
				;ElseIf $vKey <> 34 AND $vKey <> 33 Then
				;	GUICtrlSetState($idEdit, $GUI_FOCUS)
				EndIf
				
        Case $NM_CUSTOMDRAW
          Local $tNMLVCUSTOMDRAW = DllStructCreate($tagNMLVCUSTOMDRAW, $lParam)
          Local $dwDrawStage = DllStructGetData($tNMLVCUSTOMDRAW, "dwDrawStage")
          Local $dwItemSpec  = DllStructGetData($tNMLVCUSTOMDRAW, "dwItemSpec")

          Switch $dwDrawStage                ; Holds a value that specifies the drawing stage

            Case $CDDS_PREPAINT
              ; Before the paint cycle begins
              Return $CDRF_NOTIFYITEMDRAW    ; Notify the parent window of any item-related drawing operations

            Case $CDDS_ITEMPREPAINT
              ; Before painting an item
							If Mod( $dwItemSpec, 2 ) = 0 Then
								DllStructSetData( $tNMLVCUSTOMDRAW, "ClrTextBk", 0xFFFFFF )
							Else
								DllStructSetData( $tNMLVCUSTOMDRAW, "ClrTextBk", 0xe3e3e3)
							EndIf
              Return $CDRF_NEWFONT           ; $CDRF_NEWFONT must be returned after changing font or colors

         EndSwitch
		  
		  
		  
      EndSwitch

  EndSwitch

  Return $GUI_RUNDEFMSG
;  #forceref $hWnd, $iMsg, $wParam
EndFunc














Func carregaListaEN()
	GUICtrlSetState($BtnReverse,$GUI_DISABLE)
	GUICtrlSetState($BtnSiglas,$GUI_DISABLE)
	
	$loading = True
	 $wp = WinGetPos($hGui)
	SplashTextOn( "LOADING...", "", 80, 0, $wp[0] + 100, $wp[1] + 320)

$aItems = ""
$aItems = FileReadToArray(@ScriptDir & "\list_EN.omf")
   ;atualiza / reseta array de busca
    For $i = 0 To ubound($aItems) - 1
        $aSearch[$i] = $i
	Next

SplashOff()
  GUICtrlSendMsg( $idLV, $LVM_SETITEMCOUNT, UBound( $aItems ), 0 )
GUICtrlSetData($idEdit, "")
GUICtrlSetState($idEdit, $GUI_FOCUS)
			
$loading = false
	
		GUICtrlSetState($BtnReverse,$GUI_ENABLE)
	GUICtrlSetState($BtnSiglas,$GUI_ENABLE)
	
	GUICtrlSetData($LblTermos, ubound($aItems) & " termos")
	
EndFunc



Func carregaListaPT()
	
	GUICtrlSetState($BtnReverse,$GUI_DISABLE)
	GUICtrlSetState($BtnSiglas,$GUI_DISABLE)
	
$loading = True
   $wp = WinGetPos($hGui)
	SplashTextOn( "LOADING...", "", 80, 0, $wp[0] + 100, $wp[1] + 220)

$aItems = FileReadToArray(@ScriptDir & "\listpt.eom")
   ;atualiza / reseta array de busca
    For $i = 0 To ubound($aItems) - 1
        $aSearch[$i] = $i
	Next

SplashOff()

$loading = false

GUICtrlSendMsg( $idLV, $LVM_SETITEMCOUNT, UBound( $aItems ), 0 )
GUICtrlSetData($idEdit, "")
GUICtrlSetState($idEdit, $GUI_FOCUS)

	GUICtrlSetState($BtnReverse,$GUI_ENABLE)
	GUICtrlSetState($BtnSiglas,$GUI_ENABLE)

GUICtrlSetData($LblTermos, ubound($aItems) & " termos")

EndFunc






Func carregaSiglasEN()

$direction = 3

$loading = True
   $wp = WinGetPos($hGui)
	SplashTextOn( "LOADING...", "", 80, 0, $wp[0] + 100, $wp[1] + 220)


if $localdebugmode = true Then
   $down = InetRead( "http://127.0.0.1:8080/app_return_siglas.php")
Else
  	$down = InetRead( "http://www.dicionariotecnico.com/app_return_siglas.php")
EndIf

$down = BinaryToString($down, 4)
; _INetGetSource 

;MsgBox(0, "Test", $down)

$aItems = ""

$aItems = _StringExplode($down, "|")

;atualiza / reseta array de busca
    For $i = 0 To ubound($aItems) - 1
        $aSearch[$i] = $i
	Next


GUICtrlSetData($LblTermos, ubound($aItems) & " termos")


SplashOff()
$loading = false

GUICtrlSendMsg( $idLV, $LVM_SETITEMCOUNT, UBound( $aItems ), 0 )
GUICtrlSetData($idEdit, "")
GUICtrlSetState($idEdit, $GUI_FOCUS)

GUICtrlSetData($CmbAreaTecnica, "<Todos os termos>")

EndFunc




Func debug()


;_IENavigate($oIE, "https://www.dicionariotecnico.com/tools.php")

;	$Index=ControlListView($hGui, "", $idLV,"GetSelected")
;	ConsoleWrite($Index)
		   ; GUICtrlSetState($idLV, $GUI_FOCUS)
;			ControlSend($hMainGUI, "", "SysListView32", "test", 1)
;                GUICtrlSetState($CmbTermos, $GUI_DISABLE)
;						ControlSend($hMainGUI, "", "[CLASS:SysListView32]", "test", 1)
;$ret = _SendMessage($hLV, $WM_KEYDOWN, $VK_DOWN, 0, -1)

;                GUICtrlSetState($CmbTermos, $GUI_ENABLE)
;			GUICtrlSetState($CmbTermos, $GUI_FOCUS)
			
		;	GUICtrlSendMsg($CmbTermos, $EM_SETSEL, 1, 3)
;		_GUICtrlListView_ClickItem($idLV, _GUICtrlListView_GetSelectedIndices($idLV))




	EndFunc
	
	Func debug2()
;	_IENavigate($oIE, "https://www.dicionariotecnico.com/copyright.php")
	EndFunc

Func _URIEncode($sData)
    ; Prog@ndy
    Local $aData = StringSplit(BinaryToString(StringToBinary($sData,4),1),"")
    Local $nChar
    $sData=""
    For $i = 1 To $aData[0]
        ; ConsoleWrite($aData[$i] & @CRLF)
        $nChar = Asc($aData[$i])
        Switch $nChar
            Case 45, 46, 48 To 57, 65 To 90, 95, 97 To 122, 126
                $sData &= $aData[$i]
            Case 32
                $sData &= "+"
            Case Else
                $sData &= "%" & Hex($nChar,2)
        EndSwitch
    Next
    Return $sData
EndFunc

	Func _OIG_IsFocused($h_Wnd, $i_ControlID) ; Check if a control has focus.
    Return ControlGetHandle($h_Wnd, '', $i_ControlID) = ControlGetHandle($h_Wnd, '', ControlGetFocus($h_Wnd))
EndFunc   ;==>_OIG_IsFocused


func __sizing($hwnd, $msg, $wp, $lp)
		dllcall('user32', 'bool', 'GetClientRect', 'hwnd', $hGUI, 'struct*', $rc)
		ConsoleWrite("Width: " & $rc.w & "; height: " & $rc.h)

  $pos = WinGetPos($hGUI);$hGUI is your GUI handle 
   ConsoleWrite("width=" & $pos[2] & "; height = " & $pos[3]);[0]=left, [1]=top, [2]=width, [3]=height


		;_IEEmbedded2_Move(300, 150, $rc.w - 310, $rc.h - 160)


;_WinAPI_MoveWindow($oIE,  300, 150,  $rc.w - 310, $rc.h - 160)
GUICtrlSetPos($GUIoIE,  300, 150,  $rc.w - 310, $rc.h - 160)
;$winhdl = WinGetHandle($oIE)
;_WinAPI_SetWindowPos($oIE, "hwnd_top", 300, 150,  $rc.w - 310, $rc.h - 160, "SWP_SHOWWINDOW")
;With $oIE
;    .Left = 300
;    .Top = 150
;    .Width =  $rc.w - 310
;    .Height = $rc.h - 160
;EndWith
;ConsoleWrite(@CRLF & "FIRST:" & _IEPropertySet ($oIE, "height",  $rc.h - 160))
;ConsoleWrite(@CRLF & "SECOND:" & _IEPropertySet ($oIE, "width",  $rc.w - 310))





GUICtrlSetPos($LblTotal,  60, $rc.h - 25, 80, 25)
	   GUICtrlSetPos($LblTermos,  110, $rc.h - 25, 150, 25)

       GUICtrlSetPos($idLV, 10, 180, 280, $rc.h - 210)
	   



   endfunc
   
   func atalhoSearch()
	   WinSetState ($hGUI, "", @SW_SHOW)
	   WinActivate($hGUI)
	   ;WinWait($hGUI)
	   
	  ; sleep(150)
	  ; ControlSend($hGUI, "", $idEdit, "{ctrl V}", 0)
		while not _OIG_IsFocused($hGUI, $idEdit) 
		  GUICtrlSetState($idEdit, $GUI_FOCUS)	
		  ConsoleWrite ("a")
		  sleep(10)
		WEnd

	   ;ControlSend($hGUI, "", $idEdit, ClipGet(), 1)
		;Send("{ctrl V}")
		Send("{CTRLDOWN}v{CTRLUP}")
		$a = 0
		while GUICtrlRead($idEdit) <> ClipGet()
		  	sleep(10)
			ConsoleWrite ("b")
		$a += 1;
		if $a > 100 Then 
			Return
		EndIf
			
		WEnd
		
		$termoatual = _URIEncode(ClipGet())
		
if $localdebugmode = true Then
	$LoadingLocation = "http://127.0.0.1:8080/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode(ClipGet())
Else		
	$LoadingLocation = "https://www.dicionariotecnico.com/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode(ClipGet())
EndIf

AdlibRegister("FinishLoading")
CarregaAnimacao()

if $localdebugmode = true Then
  	_IENavigate($oIE, "http://127.0.0.1:8080/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode(ClipGet()))
Else
	_IENavigate($oIE, "https://www.dicionariotecnico.com/" & $page & "?opt=1&dir=" & ($modoSearch = 1 ? $direction : "4") & "&termo=" & _URIEncode(ClipGet()))
EndIf

 			GUICtrlSetState($idEdit, $GUI_FOCUS)	
			   ControlSend($hGUI, "", $idEdit, "{RIGHT}", 0)
           ; Sleep(250)
		   
;	   sleep(150)

;	   sleep(150)
	   
;
	   GUICtrlSetState($idEdit, $GUI_FOCUS)
;	   ControlSend($hGUI, "", $idEdit, "{ENTER}", 0)
;	   ControlSend($hGUI, "", $idEdit, "{ENTER}", 0)
	   sleep(150)

EndFunc

Func ResetAreaTecnica()
	
	_GUICtrlComboBox_SelectString($CmbAreaTecnica, "<Todos os termos>")
	;ControlSetText($hGUI,"",$CmbAreaTecnica,"<Todos os termos>")
	
    if $direction = 1 Then
		carregaListaEN()
	Else
		carregaListaPT()
	EndIf

EndFunc


Func LoadAreaTecnica()
	
local $area = GUICtrlRead($CmbAreaTecnica)
if $area = "<Todos os termos>" Then
    if $direction = 1 Then
		carregaListaEN()
	Else
		carregaListaPT()
	EndIf

return
EndIf

local $codArea
; $direction  ing -> pt = 1; pt -> ing = 2


$loading = True
   $wp = WinGetPos($hGui)
	SplashTextOn( "LOADING...", "", 80, 0, $wp[0] + 100, $wp[1] + 220)


switch $area

case "Tecnologia/Geral"
$codArea = 1
case "Expressão Técnica"
$codArea = 2
case "Engenharia Mecânica"
$codArea = 3
case "Biotecnologia & Genética"
$codArea = 4
case "Telecomunicações"
$codArea = 5
case "Informática, Software e Processamento de Dados"
$codArea = 6
case "Manufatura e Produção"
$codArea = 7
case "Medicina"
$codArea = 8
case "Metalurgia, Moldagem e Fundição"
$codArea = 9
case "Construção Civil"
$codArea = 10
case "Patentes e Propriedade Intelectual"
$codArea = 11
case "Engenharia Automotiva"
$codArea = 12
case "Anatomia"
$codArea = 13
case "Química, Bioquímica e Polímeros"
$codArea = 14
case "Farmacologia"
$codArea = 15
case "Aviação"
$codArea = 16
case "Matemática, Álgebra e Geometria"
$codArea = 17
case "Estatística"
$codArea = 18
case "Física"
$codArea = 19
case "Eletrônica, Eletricidade e Magnestismo"
$codArea = 20
case "Logística"
$codArea = 21
case "Soldagem"
$codArea = 22
case "Engenharia Naval"
$codArea = 23
case "Petróleo & Gás"
$codArea = 24
case "Gramática e Linguística"
$codArea = 25
case "Mineralogia"
$codArea = 26
case "Odontologia"
$codArea = 27
case "Oftalmologia"
$codArea = 28
case "Engenharia Ferroviaria"
$codArea = 29
case "Têxtil, Vestuário e Moda"
$codArea = 30
case "Ciências Agrárias"
$codArea = 31
case "Psicologia"
$codArea = 32
case "Tipografia"
$codArea = 33
case "Pneumáticos"
$codArea = 34
case "Geologia"
$codArea = 35
case "Engenharia Espacial"
$codArea = 36
case "Biologia"
$codArea = 37
case "Cerâmica"
$codArea = 38
case "Sistemas de medição"
$codArea = 39
case "Meteorologia"
$codArea = 40
case "Cristalografia"
$codArea = 41
case "Óptica"
$codArea = 42
case "Definição Contextual"
$codArea = 43
case "Expressão Idiomática"
$codArea = 44
case "Impressão & Gráfica"
$codArea = 45
case "Geografia"
$codArea = 46
case "Botânica"
$codArea = 47
case "Arquitetura"
$codArea = 48
case "Marketing"
$codArea = 49
case "Fisiologia"
$codArea = 50
case "Economia"
$codArea = 51
case "Saneamento"
$codArea = 52
case "Militar"
$codArea = 53
case "Engenharia Ambiental"
$codArea = 54
case "Astronomia"
$codArea = 55
case "Mineração"
$codArea = 56
case "Topografia"
$codArea = 57
case "Usinagem"
$codArea = 58
case "Geofísica"
$codArea = 59
case "Cerâmica"
$codArea = 60
case "Hidráulica"
$codArea = 61
case "Carpintaria"
$codArea = 62
case "Zoologia"
$codArea = 63
case "Recursos Humanos"
$codArea = 64
case "Finanças e Contabilidade"
$codArea = 65
case "Engenharia Civil"
$codArea = 66
case "Jurídica"
$codArea = 67
case "Engenharia de Materiais"
$codArea = 68
case "Fotografia"
$codArea = 69
case "Ferramentas"
$codArea = 70
case "Fonética"
$codArea = 72
case "Microbiologia"
$codArea = 73
case "Cromatografia"
$codArea = 74
case "Ensaios Clínicos"
$codArea = 75
case "Bioestatística"
$codArea = 76
case "Engenharia de Trânsito"
$codArea = 77
case "Engenharia Civil"
$codArea = 78
case "Acústica"
$codArea = 79
case "Comércio Exterior"
$codArea = 80
case "Administração"
$codArea = 81
case "Navegação"
$codArea = 82
case "Análises Laboratoriais"
$codArea = 83
case "Sociologia"
$codArea = 84
case "Filosofia"
$codArea = 85
case "Jogos Eletrônicos"
$codArea = 86
case "Termos Acadêmicos"
$codArea = 87
case "Enfermagem"
$codArea = 89
case "Direito Societário"
$codArea = 88
EndSwitch

if $direction = 3 or $direction = 4 Then
	$direction = 1
EndIf

if $localdebugmode = true Then
	$down = InetRead( "http://127.0.0.1:8080/app_return_list.php?area=" & $codArea & "&direction=" & $direction)
Else
	$down = InetRead( "https://www.dicionariotecnico.com/app_return_list.php?area=" & $codArea & "&direction=" & $direction)
EndIf
$down = BinaryToString($down, 4)
; _INetGetSource 

;MsgBox(0, "Test", $down)

$aItems = ""

$aItems = _StringExplode($down, "|")

;atualiza / reseta array de busca
    For $i = 0 To ubound($aItems) - 1
        $aSearch[$i] = $i
	Next


GUICtrlSetData($LblTermos, ubound($aItems) - 1& " termos")


SplashOff()
$loading = false

GUICtrlSendMsg( $idLV, $LVM_SETITEMCOUNT, UBound( $aItems ) - 1, 0 )
GUICtrlSetData($idEdit, "")
GUICtrlSetState($idEdit, $GUI_FOCUS)

	
	
EndFunc


Func FinishLoading()
;	ConsoleWrite ("a1")
;	ConsoleWrite ("b1")
	ConsoleWrite (@CRLF & "1)" & _IEPropertyGet($oIE, "locationurl"))
	ConsoleWrite (@CRLF & "2)" & $LoadingLocation)
if  _IEPropertyGet($oIE, "locationurl") = $LoadingLocation Then 
;	ConsoleWrite ("b1")
;    	$LoadingLocation = _IEPropertyGet($oIE, "locationurl")
    	TerminaAnimacao()
        AdlibUnRegister("FinishLoading")
	EndIf

; APOS O CARREGAMENTO DA PAGINA, VERIFICA SE USUARIO ESTA LOGADO
; SE NAO ESTIVER, EXIBE BOTAO
$code = _IEBodyReadHTML($oIE)
if StringInStr($code, ">LOGIN</a>")   then  ; Usuário não logado, exibe botão de login no proprio app para abrir no chrome
   GUICtrlSetState($BtnAssine, $GUI_SHOW)
Else
   GUICtrlSetState($BtnAssine, $GUI_HIDE)
EndIf



EndFunc














Func CarregaAnimacao()

;GUICtrlSetState($idLV,$GUI_DISABLE)
SplashImageOn("", @ScriptDir & "\loading.gif",311,69,-1,-1,1)

EndFunc

Func TerminaAnimacao()

SplashOff()
;GUICtrlSetState($idLV,$GUI_ENABLE)
EndFunc
		
