﻿; Includes
#include-once
#include 'cefau3.au3'
#include 'Json.au3' ; (by @AspirinJunkie)

#include <GUIConstants.au3>
#include <WindowsConstants.au3>
#include <GuiListView.au3>
#include <Array.au3>
#include <WinAPI.au3>
#include <FontConstants.au3>
#include <ColorConstants.au3>

#include <Misc.au3>
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <StaticConstants.au3>
#include <GuiComboBox.au3>
#include <ClipBoard.au3>
#include <WinAPIDiag.au3>
#include <Inet.au3>



Global $hLV, $aItems, $idLV, $idSearchText, $HandleidSearchText




  ; Create GUI
  $hMainGUI = GUICreate( "GLOSSARIUM Inglês <> Português - www.dicionariotecnico.com ", 1280, 750 ,-1,-1,BitOr($WS_MINIMIZEBOX, $WS_MAXIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU, $WS_SIZEBOX))

$hFont = _WinAPI_CreateFont(21, 9, 0, 0, $FW_NORMAL, False, False, False, $DEFAULT_CHARSET, $OUT_DEFAULT_PRECIS, $CLIP_DEFAULT_PRECIS, $DEFAULT_QUALITY, 0, 'Arial')

$idSearchText = GUICtrlCreateEdit("", 10, 70, 300, 30)
$HandleidSearchText = GUICtrlGetHandle( $idSearchText )

  ; Create ListView
$idLV = GUICtrlCreateListView( "", 10, 100, 303, 500, BitOr($LVS_SORTASCENDING,$LVS_SINGLESEL, $LVS_EX_BORDERSELECT, $LVS_OWNERDATA, $LVS_NOCOLUMNHEADER, $LVS_SHOWSELALWAYS), BitOR( $WS_EX_CLIENTEDGE, $LVS_EX_DOUBLEBUFFER, $LVS_EX_FULLROWSELECT, $LVS_EX_FLATSB,$LVS_EX_INFOTIP))
  $hLV = GUICtrlGetHandle( $idLV ) ;                               Virtual listview                          Reduces flicker
_WinAPI_SetFont($hLV, $hFont, True)
_GUICtrlListView_SetOutlineColor ( $hLV, $CLR_WHITE)
_GUICtrlListView_SetTextBkColor ( $hLV, 0xfcfcfc )
_GUICtrlListView_SetOutlineColor ( $hLV, 0xffffe8 )
_GUICtrlListView_SetBkColor ( $hLV, 0xf2f2f2 )

  _GUICtrlListView_AddColumn( $hLV, "", 280 )

  ; WM_NOTIFY message handler
  GUIRegisterMsg( $WM_NOTIFY, "WM_NOTIFY" )
  GUIRegisterMsg($WM_COMMAND, "WM_COMMAND")
  GUISetState( @SW_SHOW )






OnAutoItExitRegister('CefExit')




 ; Load data from CSV-file
  $aItems = FileReadToArray("preliminar.txt")
  ;_ArraySort($file,0, 0, 0, 0, 1)
 ; msgbox(0,"",UBound( $file ))
 ; $aItems = _ArrayUnique($file)
 ;   msgbox(0,"",UBound( $aItems ))
 ; $aItems = FileReadToArray("LvVirtCSVfile.csv")
  
  ;msgbox(0,"",UBound( $aItems ))
  GUICtrlSendMsg( $idLV, $LVM_SETITEMCOUNT, UBound( $aItems ), 0 )



  ; Message loop
  While 1
	 ; msgbox(0,"","a")
    Switch GUIGetMsg()
      Case $GUI_EVENT_CLOSE
        ExitLoop
    EndSwitch
  WEnd

 ; GUIDelete()





Func WM_COMMAND($hWnd, $iMsg, $wParam, $lParam)
    Local $hdlWindowFrom, _
          $intMessageCode, _
          $intControlID_From

    $intControlID_From =  BitAND($wParam, 0xFFFF)
    $intMessageCode = BitShift($wParam, 16)

    Switch $intControlID_From
        Case $idSearchText
            Switch $intMessageCode
                Case $EN_CHANGE
                    ConsoleWrite("[" & _Now() & "] - The text in the $txtInput control has changed! Text = " & GUICtrlRead($idSearchText) & @CRLF)
					GUICtrlSetState($idLV, $GUI_FOCUS)
					   ; msgbox(0, SearchText(DllStructGetData($tNMLVFINDITEM, "Start" ), GUICtrlRead($idSearchText)  ) )
					ControlSend($hMainGUI, "", $idLV, GUICtrlRead($idSearchText), 1)
					;GUICtrlSetState($idSearchText, $GUI_FOCUS)
            EndSwitch
    EndSwitch

    Return $GUI_RUNDEFMSG

EndFunc




Func WM_NOTIFY( $hWnd, $iMsg, $wParam, $lParam )
  Static $tagNMLVCACHEHINT = $tagNMHDR & ";int iFrom;int iTo"
  Static $tText = DllStructCreate( "wchar[50]" )
  Static $pText = DllStructGetPtr( $tText )
  Static $aDisplay[100][10], $iRows, $iFrom


  Local $tNMHDR = DllStructCreate( $tagNMHDR, $lParam )
  Local $hWndFrom = HWnd( DllStructGetData( $tNMHDR, "hWndFrom" ) )
  Local $iCode = DllStructGetData( $tNMHDR, "Code" )

  Switch $hWndFrom


    Case $hLV


				
      Switch $iCode

                Case $NM_CLICK ; Sent by a list-view control when the user clicks an item with the left mouse button
					ConsoleWrite($lParam)
					
                    $tInfo = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					$index = DllStructGetData($tInfo, "Index")
                    _DebugPrint($aItems[$index])
					;$cef_frame = $cef_browser.GetMainFrame()
					;sleep(500)
					;$cef_frame.LoadURL("127.0.0.1/traducao.php?termo=" & _URIEncode($aItems[$index]))
					
			
                Case $LVN_KEYDOWN
                    $tNMLVKEYDOWN = DllStructCreate($tagNMHDR & ";short VKey;uint Flags", $lParam)
					
					$vKey = DllStructGetData($tNMLVKEYDOWN, "VKey")
					
                    ConsoleWrite("Virtual key code: " & $vKey & @LF)
					
					
					If $vKey = 38 or $vKey = 40 Then
						
						;ConsoleWrite(_GUICtrlListView_GetSelectedIndices($idLV))
                   ; $tInfo = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					;$index = DllStructGetData($tInfo, "Index")
					
					;GUICtrlSetData($idSearchText,$aItems[_GUICtrlListView_GetSelectedIndices($idLV)])
					 _GUICtrlEdit_SetText($idSearchText,$aItems[_GUICtrlListView_GetSelectedIndices($idLV)] )
                    
					  
				  EndIf
				  
        Case $LVN_GETDISPINFOW
          Local $tNMLVDISPINFO = DllStructCreate( $tagNMLVDISPINFO, $lParam )
          If BitAND( DllStructGetData( $tNMLVDISPINFO, "Mask" ), $LVIF_TEXT ) Then
            Local $iIndex = DllStructGetData( $tNMLVDISPINFO, "Item" ) - $iFrom
            If $iIndex >= 0 And $iIndex < $iRows Then
              Local $sItem = $aDisplay[$iIndex][DllStructGetData($tNMLVDISPINFO,"SubItem")]
              DllStructSetData( $tText, 1, $sItem )
              DllStructSetData( $tNMLVDISPINFO, "Text", $pText )
              DllStructSetData( $tNMLVDISPINFO, "TextMax", StringLen( $sItem ) )
            EndIf
          EndIf

        Case $LVN_ODCACHEHINT
          Local $tNMLVCACHEHINT = DllStructCreate( $tagNMLVCACHEHINT, $lParam )
          Local $iTo = DllStructGetData( $tNMLVCACHEHINT, "iTo" ), $aSubItems
          $iFrom = DllStructGetData( $tNMLVCACHEHINT, "iFrom" )
          $iRows = 0
          For $i = $iFrom To $iTo
            ;$aSubItems = StringSplit( $aItems[$i], ",", 2 ) ; 2 = $STR_NOCOUNT
	
              $aDisplay[$iRows][0] = $aItems[$i]

            $iRows += 1
          Next

Case $LVN_ODFINDITEMW
  Local $tNMLVFINDITEM = DllStructCreate( $tagNMLVFINDITEM, $lParam )
  If BitAND( DllStructGetData( $tNMLVFINDITEM, "Flags" ), $LVFI_STRING ) Then
    Return SearchText( DllStructGetData( $tNMLVFINDITEM, "Start" ), _                                     ; Start
      DllStructGetData( DllStructCreate( "wchar[20]", DllStructGetData( $tNMLVFINDITEM, "Text" ) ), 1 ) ) ; Text
  EndIf



        Case $NM_CUSTOMDRAW
          Local $tNMLVCUSTOMDRAW = DllStructCreate($tagNMLVCUSTOMDRAW, $lParam)
          Local $dwDrawStage = DllStructGetData($tNMLVCUSTOMDRAW, "dwDrawStage")
          Local $dwItemSpec  = DllStructGetData($tNMLVCUSTOMDRAW, "dwItemSpec")

          Switch $dwDrawStage                ; Holds a value that specifies the drawing stage

            Case $CDDS_PREPAINT
              ; Before the paint cycle begins
              Return $CDRF_NOTIFYITEMDRAW    ; Notify the parent window of any item-related drawing operations

            Case $CDDS_ITEMPREPAINT
              ; Before painting an item
							If Mod( $dwItemSpec, 2 ) = 0 Then
								DllStructSetData( $tNMLVCUSTOMDRAW, "ClrTextBk", 0xFFFFFF )
							Else
								DllStructSetData( $tNMLVCUSTOMDRAW, "ClrTextBk", 0xe3e3e3)
							EndIf
              Return $CDRF_NEWFONT           ; $CDRF_NEWFONT must be returned after changing font or colors

          EndSwitch
		  
		  
		  
      EndSwitch

  EndSwitch

  Return $GUI_RUNDEFMSG
  #forceref $hWnd, $iMsg, $wParam
EndFunc






Func SearchText( $lo, $s )
	ConsoleWrite($lo & " - " & $s & @CRLF)
	Local $lo0 = $lo
	If $lo > UBound( $aItems ) - 1 Then
		$lo = 0
	EndIf
		
	If Not StringCompare( $s, StringLeft( $aItems[$lo], StringLen( $s ) ) ) Then
		; Current row ($lo) matches search string
		Return $lo
	EndIf

	; Search from current row ($lo) to last row
	Local $hi = UBound( $aItems ) - 1, $mi
	$mi = BinSearch( $lo, $hi, $s )
	If $mi > -1 Then
		; Found
		Return $mi
	EndIf

	; Not found
	If $lo0 < UBound( $aItems ) - 1 Then
		; Search from first row to current row ($lo)
		$lo = 0
		$hi = $lo0
		Return BinSearch( $lo, $hi, $s )
	EndIf

	Return -1
EndFunc

Func BinSearch( $lo, $hi, $s )
	Local $mi, $l = StringLen( $s ), $t
	While $lo <= $hi
		$mi = Int( ( $lo + $hi ) / 2 )
		$t = StringLeft( $aItems[$mi], $l )
		If StringCompare( $s, $t ) < 0 Then
			$hi = $mi - 1
		ElseIf StringCompare( $s, $t ) > 0 Then
			$lo = $mi + 1
		Else ; Found
			; Find first row that matches the string
			While $mi And Not StringCompare( $s, StringLeft( $aItems[$mi-1], $l ) )
				$mi -= 1
			WEnd
			Return $mi
		EndIf
	WEnd
	Return -1
EndFunc


Func _DebugPrint($s_text, $line = @ScriptLineNumber)
    ConsoleWrite( _
            "!===========================================================" & @LF & _
            "+======================================================" & @LF & _
            "-->Line(" & StringFormat("%04d", $line) & "):" & @TAB & $s_text & @LF & _
            "+======================================================" & @LF)
		EndFunc   ;==>_DebugPrint
		
		



func __exit()
	GUISetState(@SW_HIDE)
exit


endfunc
